codeforces 214B

【题意描述】

本题就是在给定的n个整数中选出若干个数字组成一个最大数并且能被2,3,5整除。

【解题思路】

我们在求最大数是否能被2,3,5整除时,首先应该满足n个数字里面必须有0,如果没有,是不能构成最大数的。当有0以后,我们需要了解一个知识,那就是一个数字乘以10的n次方后除3的余数仍然是原来那个数字。那么我们就可以研究这n个数字与3的关系,进而研究整体。如果这n个数字加起来的整体之和除3的余数为1,那么我们需要删除一个余数为1的数(该数尽量小),或者删除两个余数为2的数字(这两个数字尽量小);当和除3的余数为2时,我们需要删除一个余数为2的数字(该数尽量小),活着的删除两个余数为1的数字(这两个数字尽量小)。

【AC代码】

#include<iostream>
#include<algorithm>
using namespace std;
#define max 100005
int num[max];
int left[max];
int vis[max];
int num_zero;
int cmp(int a,int b)
{
    return a>b;
}
int main()
{
    int n;
    while(cin>>n)
    {
        int a,judge=0;
        memset(vis,1,sizeof(vis));
        for(int i=0;i<n;i++)
        {
            cin>>num[i];
            if(num[i]==0) judge=1;  //记录0的个数
        }
        if(!judge) {cout<<-1<<endl;continue;}
        else
        {
          sort(num,num+n,cmp);//排序
          int sum_total=0;
          int left_one,left_zero,left_two;
          for(int i=0;i<n;i++)
            {
                left[i]=num[i]%3;
                if(left[i]==2)
                left_two++;
                else if(left[i]==1)
                    left_one++;
                else if(left[i]==0)
                    left_zero++;
                sum_total+=left[i];
            }
            sum_left=sum_total%3;
          if(sum_left==0)//直接被整除
          {
              if(num[0]==0)  cout<<0<<endl;
              else
                for(int i=0;i<n;i++)
                cout<<num[i];
                cout<<endl;
          }
          else if(sum_left==1)//余数为1
          {
            if(left_one!=0)
                for(int i=n-1;i>=0;i--)
            if(left[i]==1){vis[i]=0;break;}
            else if(left_one==0&&left_two>=2)
            for(int i=n-1,count1=0;i>=0;i--)
            {
             if(left[i]==2)  {count1++;vis[i]=0;}
             if(count1==2)   break;
            }
            int count_vis=0;
            for(int i=0;i<=n-1;i++)//寻找最后剩下的数字是否有正数
                if(vis[i]&&num[i]>0) count_vis++;
            if(count_vis==0)  cout<<0<<endl;
            else
                {for(int i=0;i<n;i++)
                  if(vis[i]) cout<<num[i];
                   cout<<endl;
                }
          }
          else if(sum_left==2)
          {
              if(left_two!=0)
                for(int i=n-1;i>=0;i--)
              if(left[i]==2){vis[i]=0;break;}
              else if(left_two==0&&left_one>=2)
                for(int i=n-1,count2=0;i>=0;i--)
              {
                  if(left[i]==1) {count2++;vis[i]=0;}
                  if(count2==2) break;
              }
              int count_vis1=0;
              for(int i=0;i<n;i++)
                if(vis[i]&&num[i]>0) count_vis1++;
                if(count_vis1==0)  cout<<0<<endl;
                else
                   {
                     for(int i=0;i<n;i++)
                    if(vis[i]) cout<<num[i];
                    cout<<endl;
                   }
          }

        }
    }
    return 0;
}

  

codeforces 214B

时间: 2024-11-10 22:01:27

codeforces 214B的相关文章

CodeForces 214B Hometask

本题求n个数组成的大数,要求是2,3,5的倍数. 因为是2 和5 的倍数,所以个位为 0:所以若n个数中没有0,直接输出-1: 难点就是要求为3 的倍数. 因为若某个数为3的倍数,则其各位数的和必然是3的倍数. 当n个数的和为3的倍数时从大到小输出便可: 当n个数的和不为3的倍数时,若n个数中有模3余数与和模3余数相同时,去掉其中最小的,否则去掉两个模3余数不为0且与和模3余数不同的数中最小的.若没有这些数,输出-1: 注意当结果为0时,不能输出前导0: ps:开始写了一个很复杂的代码,后来看过

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l